/*
(C) 2008 Michael Chaten
This file is part of GoodGame.

GoodGame is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

GoodGame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.sf.goodgame.tbgf.games.desdemona.client.test;

import javax.swing.JFrame;
import javax.swing.WindowConstants;
import net.sf.goodgame.tbgf.games.desdemona.client.DesdemonaUI;
import net.sf.goodgame.tbgf.games.desdemona.shared.Piece;

/**
 *
 * @author Mike
 */
public class DesdemonaUITest {

    
    public static void main(String [] args)
    {
        try
        {
            DesdemonaUI ui = new DesdemonaUI(null,null);
            ui.setBoardSize((byte)8);
            JFrame frame = new JFrame("Test");
            Piece p = Piece.black;
            frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
            frame.setSize(1024,768);
            frame.setContentPane(ui);
            frame.setVisible(true);
            for(byte i = 0;i<8;i++)
            {
                for(byte j = 0;j<8;j++)
                {
                    p = p==Piece.black?Piece.white:Piece.black;
                    ui.setPiece(i, j, p);
                    synchronized(frame)
                    {
                        frame.wait(100); 
                    }
                   
                }
            }
        }catch(Exception e)
        {
            e.printStackTrace();
        }
    }
}
