/*
(C) 2008 Michael Chaten
This file is part of GoodGame.

GoodGame is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

GoodGame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.tbgf.games.desdemona.shared;

import net.sf.goodgame.shared.Util;

/**
 *
 * @author mchaten
 */
public class Move {

    public final byte X;
    public final byte Y;
    
    private byte[] xdirections;
    private byte[] ydirections;
    private byte index;
    public Move(byte x, byte y)
    {
        X = x;
        Y = y;
        index = 0;
        xdirections = new byte[8];
        ydirections = new byte[8];
        for(int i = 0;i < 8 ; i++)
        {
            xdirections[i] = ydirections[i] = 0;
        }
    }
        
    public byte[] getNetworkMessage()
    {
        return Util.combineArrays(new byte[]{X,Y,index},xdirections,ydirections);
    }
    public static Move getMove(byte[] networkMessage,short read)
    {
        if(networkMessage.length - read == 19)
        {
            Move m = new Move(networkMessage[read],networkMessage[read+1]);
            read+=2;
            m.index = networkMessage[read++];
            m.xdirections = Util.extractArray(networkMessage,read,8);
            read+=8;
            m.ydirections = Util.extractArray(networkMessage, read,8);
            return m;
        }
        else
            return null;
    }
    public byte getDeltaX(int i )
    {
        return xdirections[i];
    }
    public byte getDeltaY(int i)
    {
        return ydirections[i];
    }
    
    public int getIndex()
    {
        return index;
    }
    public void setDirection(byte x, byte y)
    {
        xdirections[index] = x;
        ydirections[index] = y;
        index++;
    }
}
