/*    
    (C) 2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * Classes that implement this interface
 *
 */
package net.sf.goodgame.tbgf.client;

import javax.swing.JPanel;
import net.sf.goodgame.shared.games.GameOptions;
import net.sf.goodgame.shared.games.Player;

public interface TurnBasedGame {
    void setGameClient(TurnBasedGameClient client);
    
    void gameMessage(String command);
    void gameMessage(byte[] command,short read);
    
    void moveTimeout();
    
    void playerJoined(Player player);
    void playerLeft(String player);
    
    JPanel getGamePanel();
    
    void gameStarted(Player me,GameOptions options);
    
    void initializeUI();

    void turnOver(Player nextTurn);
    
}
