/*    
    (C) 2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package net.sf.goodgame.tbgf.test.client;

import javax.swing.JPanel;
import net.sf.goodgame.shared.games.GameOptions;
import net.sf.goodgame.shared.games.Player;
import net.sf.goodgame.tbgf.client.TurnBasedGame;
import net.sf.goodgame.tbgf.client.TurnBasedGameClient;

public class DummyGame implements TurnBasedGame{

    private DummyGameGUI gui;
    private DummyGameClient client;
    public DummyGame()
    {
    }
    public void gameOver() {
        gui.setText("Game Over");
    }

    public void gameStarted(Player me,GameOptions options) {
        gui.setText("Game Started");
    }

    public JPanel getGamePanel() {
        return gui;
    }

    public void moveTimeout() {
        gui.setText("Timeout");
    }

    public void playerJoined(Player player) {
        gui.setText("Player: "+player+" joined");
    }

    public void playerLeft(String player) {
        gui.setText("Player: "+player+" left");
    }

    public void gameMessage(String command) {
        gui.setText("move string");
    }

    public void gameMessage(byte[] command,short read) {
        gui.setText("move binary");
    }

    public void setGameClient(TurnBasedGameClient client) {
        this.client =(DummyGameClient) client;
        gui = new DummyGameGUI((DummyGameClient)client);
    }
    public void initializeUI()
    {
        gui.initializeUI();
    }

    public void turnOver(Player nextTurn) {
        return;
    }


}
