/*    
    (C) 2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.goodgame.tbgf.test.server;

import java.util.Vector;
import net.sf.goodgame.shared.games.Player;
import net.sf.goodgame.tbgf.server.TurnBasedGame;

public class DummyGame implements TurnBasedGame{
    private Vector<Player> players;
    private DummyGameServer server;
    public DummyGame(DummyGameServer server)
    {
        this.server = server;
        players = new Vector<Player>();
    }
    @Override
    public void moveTimeout() {
        return;
    }

    public Player getCurrentTurn() {
        return players.firstElement();
    }

    @Override
    public void playerJoined(Player player) {
        players.add(player);
        if(players.size() == 2)
        {
            server.gameStarted();
        }
    }

    @Override
    public void playerLeft(Player player) {
        return;
    }

    @Override
    public void gameMessage(Player player, String command) {
        System.out.println("Move:String");
        server.sendMessage(new byte[0]);
    }

    @Override
    public void gameMessage(Player player, byte[] command,short read) {
        System.out.println("Move:Binary");
        server.sendMessage(new byte[0]);
    }

}
