/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.game;

import java.awt.Color;
import java.awt.Component;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

/**
 *
 * @author Mike
 */
public class GameTableCellRenderer extends DefaultTableCellRenderer {

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        Component c = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
        if (c instanceof JLabel) {

            //We get a better looking font if we do not use the default table font.
            JLabel label = new JLabel(((JLabel) c).getText());
            label.setOpaque(false);
            label.setHorizontalAlignment(SwingConstants.CENTER);
            if (column == table.getColumnCount() -1) {
                label.setBorder(BorderFactory.createLineBorder(Color.BLACK));
            } else {
                label.setBorder(BorderFactory.createMatteBorder(1, 0, 1, 1, Color.BLACK));
            }
            return label;
        }
        return c;
    }
}
