/*    
(C) 2007,2008 yura.net
This file is part of Lobby.

Lobby is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License

Lobby is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui;

import javax.swing.JApplet;
import javax.swing.UIManager;

/**
 * A very simple applet.
 */
public class GGApplet extends JApplet {

    Main gui;

    @Override
    public void init() {
        try {
             if(System.getProperty("os.name").contains("Windows"))
             {
                 UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
             }
             else //There are some bugs in the linux look and feel for GTK that are not there in windows.
                 //TODO: Check Mac SystemLookAndFeel
             {
                 UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
             }
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        
        createGUI();


    }

    private void createGUI() {



        String serv = getParameter("server");
        String port = getParameter("port");


        // applet defaults

        if (serv == null) {

            serv = getCodeBase().getHost();

        }

        if (serv == null) {
            //When release, change to our domain name.
            serv = "localhost";

        }

        if (port == null) {

            port = "13375";

        }


        gui = new Main(getCodeBase(), serv, Integer.parseInt(port));
        setContentPane(gui);

        gui.setArt(getParameter("back"), getParameter("logo"), getParameter("color"));
    }

    @Override
    public void start() {

        gui.setVisible(true);
        gui.connect();
        super.start();
    }

    @Override
    public void stop() {

        gui.setVisible(false);
        gui.disconnect();
        super.stop();
    }
}
