/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.sf.goodgame.client.gui;

import java.util.List;
import javax.swing.SwingUtilities;
import net.sf.goodgame.client.gametype.GameType;
import net.sf.goodgame.shared.UserInfoElement;
import net.sf.goodgame.shared.UserType;

/**
 *
 * @author mchaten
 */
public class GUIDispatcher implements GoodGameUI{
    private final GoodGameUI ui;
    public GUIDispatcher(GoodGameUI ui) {
        this.ui = ui;
    }
    public void serverMessage(final String message) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.serverMessage(message);
            }
        });
    }

    public void switchGameType(final GameType gt) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.switchGameType(gt);
            }
        });
    }

    public void switchLobby(final short id) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.switchLobby(id);
            }
        });
    }

    public void showUserInfo(final String username,final  List<UserInfoElement> userInfos) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.showUserInfo(username,userInfos);
            }
        });
    }

    public void login(final String name,final  UserType type) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.login(name,type);
            }
        });
    }

    public void showError(final String error) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.showError(error);
            }
        });
    }

    public void connecting(final String message) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.connecting(message);
            }
        });
    }

    public void connected() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.connected();
            }
        });
    }

    public void disconnected() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.disconnected();
            }
        });
    }

    public void joinGame(final GameType gt) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.joinGame(gt);
            }
        });
    }

    public void leaveGame() {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                ui.leaveGame();
            }
        });
    }

}
