/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui;

import java.util.List;
import net.sf.goodgame.client.gametype.GameType;
import net.sf.goodgame.shared.UserInfoElement;
import net.sf.goodgame.shared.UserType;

/**
 *
 * @author Mike
 */
public interface GoodGameUI {

    void serverMessage(String message);

    void switchGameType(GameType gt);

    void switchLobby(short id);

    void showUserInfo(String username,List<UserInfoElement> userInfos);

    void login(String name, UserType type);

    void showError(String error);

    void connecting(String message);

    void connected();

    void disconnected();

    void joinGame(GameType gt);

    void leaveGame();
}
