/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.chat;

import java.util.concurrent.ConcurrentHashMap;
import net.sf.goodgame.client.networking.OutgoingConnection;

/**
 *
 * @author mchaten
 */
public class PrivateChatController {

    private ConcurrentHashMap<String,PrivateChatWindow> privateChats;
    private OutgoingConnection network;
    public PrivateChatController(OutgoingConnection out)
    {
        privateChats = new ConcurrentHashMap<String,PrivateChatWindow>();
        network = out;
    }
            
    public void privateMessage(String fromwho, String message)
    {
        getPrivateChatWindow(fromwho).incomingChat(message);
    }
    public PrivateChatWindow getPrivateChatWindow(String withUser)
    {
        PrivateChatWindow chatWindow = privateChats.get(withUser);
        if(chatWindow == null)
        {
            chatWindow = new PrivateChatWindow(withUser,network);
            privateChats.put(withUser, chatWindow);
        }
        chatWindow.requestFocus();
        return chatWindow;
    }
}
