/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.chat;

import net.sf.goodgame.client.gui.chat.ChatBox;
import javax.swing.JFrame;
import net.sf.goodgame.client.networking.OutgoingConnection;

/**
 *
 * @author mchaten
 */
public class PrivateChatWindow {

    private final String chatWith;
    private final ChatBox chatBox;
    private final JFrame frame;
    public PrivateChatWindow(String with,OutgoingConnection out)
    {
        chatWith = with;
        chatBox = new ChatBox(with,out,true);
        frame = new JFrame("Chat with: "+with);
        frame.getContentPane().add(chatBox);
        frame.setSize(300,300);
        frame.setVisible(true);
    }
    public void incomingChat(String message)
    {
        chatBox.incomingChat(chatWith, message);
    }
    public void requestFocus()
    {
        frame.setVisible(true);
        frame.requestFocus();
    }
}
