/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.table.button;

import java.awt.Component;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.AbstractCellEditor;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;
import net.sf.goodgame.client.game.Game;
import net.sf.goodgame.client.gui.translucency.TranslucentJButton;
import net.sf.goodgame.client.networking.OutgoingConnection;

public class ButtonEditor extends AbstractCellEditor implements TableCellEditor, ActionListener {

    
    private JButton button = new TranslucentJButton(0.6f);
    private Game game;
    private final OutgoingConnection connection;

    public ButtonEditor(OutgoingConnection connection) {

        button.addActionListener(this);
        button.setMargin(new Insets(0, 0, 0, 0));
        this.connection = connection;
    }

    public void actionPerformed(ActionEvent ae) {
        String a = ae.getActionCommand();
        if (a.equals("join")) { //Join
            connection.joinGame(game);
        } else if (a.equals("")) {
            //Do nothing
        } else {
            System.out.println("BUG: " + a + " is not implemented yet");
        }
        cancelCellEditing();
    }

    public Component getTableCellEditorComponent(JTable table, Object value,
            boolean isSelected, int row, int column) {
        game = (Game) table.getValueAt(row,table.getColumnCount()-1);
        ButtonUtil.setupButton(button, game);
        return button;

    }

    public Object getCellEditorValue() {
        throw new RuntimeException("Editing not allowed");
    }

    @Override
    public boolean stopCellEditing() { // when ever it stops, just cancel it so no update happens

        cancelCellEditing();
        return true;

    }
}
