/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.table.button;

import java.awt.Color;
import javax.swing.JButton;
import net.sf.goodgame.client.game.Game;

public class ButtonUtil {

    public static void setupButton(JButton button,Game game) {
        switch (game.getState()) {
            case canJoin:
                button.setActionCommand("join");
                button.setText("join");
                button.setBackground(Color.GREEN);
                button.setForeground(Color.BLACK);
                break;
            case loading:
            case playing:
                button.setActionCommand("join");
                button.setText("Spectate");
                button.setBackground(Color.yellow);
                button.setForeground(Color.black);
                break;
            case finished:
                button.setActionCommand("");
                button.setText("Game Over");
                button.setBackground(Color.gray);
                button.setForeground(Color.black);
                break;
        }

    }
}
