/*
(C) 2007,2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.translucency;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;

import java.awt.Insets;
import javax.swing.BorderFactory;
import javax.swing.JButton;

public class TranslucentJButton extends JButton {

	private final float translucency;
        public TranslucentJButton(String text, float t)
        {
            this(t);
            this.setText(text);
        }
	public TranslucentJButton(float t)
	{
		translucency = t;
		setOpaque(false);
                setMargin(new Insets(0, 0, 0, 0));
                setBorder(BorderFactory.createEmptyBorder());
                setContentAreaFilled(false);
                this.setBackground(new Color(63,54,49));
                this.setForeground(Color.white);
                this.setPreferredSize(new Dimension(75,30));
	}
        @Override
	public void paintComponent(Graphics g)
	{			
		Color oldColor = g.getColor();
		Graphics2D g2d = (Graphics2D)g;
		Composite oldComp = g2d.getComposite();
		g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,translucency));
		g2d.setColor(getBackground());
		g2d.fillRect(0,0,getWidth(),getHeight());
		g2d.setColor(oldColor);
		g2d.setComposite(oldComp);
		super.paintComponent(g);
	}
}
