/*
(C) 2007,2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.translucency;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Component;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.JViewport;

public class TranslucentJScrollPane extends JScrollPane {

	private final float translucency;
	public TranslucentJScrollPane(float t)
	{
		this(null,t);
	}

	public TranslucentJScrollPane(Component arg0,float t) {
		super(arg0);
		setOpaque(false);
		getViewport().setOpaque(false);
		translucency = t;
		setBorder(BorderFactory.createEmptyBorder());
                //setBackground(new Color(63,54,49));
                setBackground(Color.white);
		//getViewport().setBackground(new Color(Color.RED.getRed(),Color.RED.getGreen(),Color.RED.getBlue(),150));
	}
        
        @Override
	public void paintComponent(Graphics g)
	{			
		Color oldColor = g.getColor();
		Graphics2D g2d = (Graphics2D)g;
		Composite oldComp = g2d.getComposite();
		g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,translucency));
		g2d.setColor(getBackground());
		g2d.fillRect(0,0,getWidth(),getHeight());
		g2d.setColor(oldColor);
		g2d.setComposite(oldComp);
		super.paintComponent(g);
	}
        @Override
	public void setColumnHeader(JViewport v)
	{
		super.setColumnHeader(v);
		v.setOpaque(false);
	}
}
