/*
(C) 2007,2008 Michael Chaten, yura.net
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.gui.tree;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Component;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.tree.TreeCellRenderer;

/**
 * Not used, kept incase we decide to use trees again.
 * @author Mike
 */
 public class TreeRenderer implements TreeCellRenderer
    {

        public Component getTreeCellRendererComponent(JTree tree, Object value, final boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus)
        {

            JLabel label = new JLabel(value.toString())
            {

                @Override
                public void paintComponent(Graphics g)
                {

                    if (selected)
                    {

                        Color oldColor = g.getColor();
                        Graphics2D g2d = (Graphics2D) g;
                        Composite oldComp = g2d.getComposite();
                        g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.5f));
                        g2d.setColor(getBackground());
                        g2d.fillRect(0, 0, getWidth(), getHeight());
                        g2d.setColor(oldColor);
                        g2d.setComposite(oldComp);
                        super.paintComponent(g);
                    } else
                    {
                        super.paintComponent(g);
                    }
                }
            };

            if (leaf)
            {
                label.setIcon((Icon) UIManager.get("Tree.leafIcon"));
            } else
            {
                if (expanded)
                {
                    label.setIcon((Icon) UIManager.get("Tree.openIcon"));
                } else
                {
                    label.setIcon((Icon) UIManager.get("Tree.closedIcon"));
                }
            }

            return label;
        }
    }
