/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.networking;

import net.sf.goodgame.client.game.GameClient;
import net.sf.goodgame.client.game.GameList;
import net.sf.goodgame.client.gametype.GameTypeList;
import net.sf.goodgame.client.gui.chat.ChatListener;
import net.sf.goodgame.client.gui.GoodGameUI;
import net.sf.goodgame.client.gui.LobbyList;
import net.sf.goodgame.client.gui.chat.PrivateChatController;
import net.sf.goodgame.client.user.friends.FriendsListener;
import net.sf.goodgame.client.user.UserList;

/**
 *
 * @author mchaten
 */
public interface IncomingConnection {

    public void setChatListener(ChatListener cl);
    
    public void setGameList(GameList gl);
    
    public void setGameTypeList(GameTypeList gtl);
    
    public void setGameClient(GameClient g);
    
    public void setUserList(UserList ul);
    
    public void setUI(GoodGameUI ui);
    
    public void setPrivateChatController(PrivateChatController controller);
    
    public void setLobbyList(LobbyList list);
    
    public void setFriendsListener(FriendsListener listener);
    
}
