/*
(C) 2008 Michael Chaten
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.networking;

import net.sf.goodgame.client.game.Game;
import net.sf.goodgame.client.gametype.GameType;

/**
 *
 * @author Mike
 */
public interface OutgoingConnection {

    public void switchGameType(GameType gt);
    
    public void joinGame(Game game);
    
    public void leaveGame();
        
    public void login(String username,String password);
    
    public void register(String username, String password, String email);
        
    public void sendChat(String message);
    
    public void sendPrivateMessage(String to, String message);
    
    public void getUserInfo(String username);
    
    public void connect();
    
    public void logout();
    
    public void switchLobby(short id);
    
    public void createGame();
    
    public void sendGameMessage(byte[] message);
    
    public void sendGameMessage(String message);
    
    public void addFriend(String friend);
    
    public void removeFriend(String friend);
}
