/*
(C) 2007,2008 Michael Chaten, yura.net
This file is part of Good Game.
Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License
Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.client.user;

import javax.swing.ImageIcon;
import net.sf.goodgame.shared.UserType;

/**
 *
 * @author Mike Chaten
 */
public class User
{
    public static final ImageIcon ICON_BLUE;
    public static final ImageIcon ICON_CYAN;
    public static final ImageIcon ICON_GRAY;
    public static final ImageIcon ICON_GREEN;
    public static final ImageIcon ICON_MAGENTA;
    public static final ImageIcon ICON_RED;
    public static final ImageIcon ICON_YELLOW;
    
    static
    {

        ICON_BLUE = new ImageIcon(User.class.getResource("icons/blue.gif"));
        ICON_CYAN = new ImageIcon(User.class.getResource("icons/cyan.gif"));
        ICON_GRAY = new ImageIcon(User.class.getResource("icons/gray.gif"));
        ICON_GREEN = new ImageIcon(User.class.getResource("icons/green.gif"));
        ICON_MAGENTA = new ImageIcon(User.class.getResource("icons/magenta.gif"));
        ICON_RED = new ImageIcon(User.class.getResource("icons/red.gif"));
        ICON_YELLOW = new ImageIcon(User.class.getResource("icons/yellow.gif"));

    }

    private String username;
    private UserType type;
    public User(String username, UserType type)
    {
        this.setUsername(username);
        this.type = type;
    }

    public ImageIcon getIcon()
    {
        switch (type)
        {
            case guest:
                return ICON_RED;
            case regular:
                return ICON_YELLOW;
            case privileged:
                return ICON_GREEN;
            case moderator:
                return ICON_BLUE;
            case admin:
                return ICON_CYAN;
            case devel:
                return ICON_GRAY;
            default:
                return ICON_MAGENTA;
        }
    }

    public void rename(String newName, UserType newType)
    {
        setUsername(newName);
        type = newType;
    }

    /**
     * @param username the username to set
     */
    public void setUsername(String username)
    {
        this.username = username;
    }

    /**
     * @return the username
     */
    public String getUsername()
    {
        return username;
    }
    @Override
    public String toString()
    {
        return getUsername();
    }

}
