package net.sf.goodgame.client.user.friends;

public class Friend {

    private final String username;
    private boolean loggedIn;
    public Friend(String username)
    {
        this.username = username;
        loggedIn = false;
    }
    public String getUsername()
    {
        return username;
    }
    public boolean isLoggedIn()
    {
        return loggedIn;
    }
    public void loggedIn()
    {
        loggedIn = true;
    }
    public void loggedOut()
    {
        loggedIn = false;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Friend other = (Friend) obj;
        if ((this.username == null) ? (other.username != null) : !this.username.equals(other.username)) {
            return false;
        }
        return true;
    }
    

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 97 * hash + (this.username != null ? this.username.hashCode() : 0);
        hash = 97 * hash + (this.loggedIn ? 1 : 0);
        return hash;
    }
    @Override
    public String toString()
    {
        return username;
    }
}
