package net.sf.goodgame.client.user.friends;

import java.util.Vector;
import javax.swing.AbstractListModel;

public class FriendsList extends AbstractListModel implements FriendsListener{

    private Vector<Friend> friends;

    public FriendsList() {
        friends = new Vector<Friend>();
    }

    public synchronized void addFriend(String user) {
        friends.add(new Friend(user));
        this.fireIntervalAdded(this, friends.size() - 1, friends.size() - 1);
    }

    public synchronized void friendLoggedIn(String user) {
        int index = friends.indexOf(new Friend(user));
        Friend friend = index >= 0 ? friends.get(index) : null;
        if (friend != null) {
            friend.loggedIn();
            this.fireContentsChanged(user, index, index);
        }
    }

    public synchronized void friendLoggedOut(String user) {
        int index = friends.indexOf(new Friend(user));
        Friend friend = index >= 0 ? friends.get(index) : null;
        if (friend != null) {
            friend.loggedOut();
            this.fireContentsChanged(user, index, index);
        }
    }

    public synchronized void removeFriend(String user) {
        int index = friends.indexOf(new Friend(user));
        if (index >= 0) {
            friends.remove(index);
            this.fireIntervalRemoved(user, index, index);
        }
    }

    public synchronized Object getElementAt(int index) {
        return friends.get(index);
    }

    public int getSize() {
        return friends.size();

    }
}
