/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sf.goodgame.client.user.userinfo;

import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import java.util.Vector;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JTabbedPane;
import net.sf.goodgame.shared.UserInfoElement;

/**
 *
 * @author mchaten
 */
public class UserInfoGUI {

    private final String username;
    private Set<UserInfoElement> elements;
    private JTabbedPane root;
    private JList userSupplied;
    private JList gameResults;

    public UserInfoGUI(String username, List<UserInfoElement> elements) {
        this.username = username;
        this.elements = new LinkedHashSet<UserInfoElement>();
        userSupplied = new JList();
        userSupplied.setCellRenderer(new UserInfoListCellRenderer());
        gameResults = new JList();
        gameResults.setCellRenderer(new UserInfoListCellRenderer());
        root = new JTabbedPane();
        root.addTab("User Supplied", userSupplied);
        root.addTab("Game Results", gameResults);
        setElements(elements);
    }

    public JComponent getComponent() {
        return root;
    }

    public void setElements(List<UserInfoElement> newElements) {
        elements.removeAll(newElements);
        elements.addAll(newElements); //Replace the old elements with the new.
        Vector<UserInfoElement> gameResultsElements = new Vector<UserInfoElement>(elements.size());
        Vector<UserInfoElement> userSuppliedElements = new Vector<UserInfoElement>(elements.size());
        for (UserInfoElement element : elements) {
            switch (element.getType()) {
                case userSupplied:
                    System.out.println("User Supplied: "+element);
                    userSuppliedElements.add(element);
                    break;
                case gameResults:
                    System.out.println("Game Result: "+element);
                    gameResultsElements.add(element);
                    break;
                default:
                    System.out.println("Unknown UserInfoType: " + element.getType());
                    break;
            }
        }
        userSupplied.setListData(userSuppliedElements);
        gameResults.setListData(gameResultsElements);
    }

    public String getUsername() {
        return username;
    }
}
