/*    
    (C) 2007,2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package net.sf.goodgame.server;

import java.util.Stack;

/**
 *
 * @author Mike
 */
public class NumberPool {

    
    private int nextNumber = 0;
    private final int maxNumber;
    private Stack<Integer> returnedNumbers = new Stack<Integer>();
    public NumberPool(int size)
    {
        maxNumber = size;
    }

    public void returnNumber(int number)
    {
        returnedNumbers.add(number);
    }

    public int nextNumber()
    {
        
        if (returnedNumbers.size() != 0)
        {
            return returnedNumbers.pop();
        } else if(nextNumber < maxNumber)
        {
            return nextNumber++; // Return the nextNumber and then increment it by 1
        }
        else return -1;

    }
}
