/*    
    (C) 2007,2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.goodgame.server;

import net.sf.goodgame.server.user.User;

/**
 *
 * @author Mike
 */
public class UserRunnable{

    public final Runnable runnable;
    public final User user;
    public UserRunnable(final User user, final Runnable runnable)
    {
        this.user = user;
        this.runnable = new Runnable()
        {
            public void run()
            {
                user.instructionExecuting();
                runnable.run();
                user.instructionFinished();
            }
        };
    }
}
