/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sf.goodgame.server.administration;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.AbstractTableModel;
import net.sf.goodgame.server.game.GameType;
import net.sf.goodgame.server.persistence.DatabaseManager;

/**
 *
 * @author mchaten
 */
public class GameTypesPane {

    private JPanel root;

    public GameTypesPane() {
        root = new JPanel();
        JTable table = new JTable();
        final GameTypesModel model = new GameTypesModel();
        table.setModel(model);
        JButton newGameTypeButton = new JButton("New Game Type");
        newGameTypeButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                Object[] message = new Object[8];
                message[0] = "Server Class Name";
                message[1] = new JTextField();
                message[2] = "Server Jar Names(comma separated)";
                message[3] = new JTextField();
                message[4] = "Client Class Name";
                message[5] = new JTextField();
                message[6] = "Client Jar Names(comma separated)";
                message[7] = new JTextField();

                String[] options = {"OK", "Cancel"};

                int result = JOptionPane.showOptionDialog(root, message, "New Game Type",
                        JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, options, options[0]);
                if (result == JOptionPane.OK_OPTION) {
                    String scn = ((JTextField) message[1]).getText();
                    String sjn = ((JTextField) message[3]).getText();
                    String ccn = ((JTextField) message[5]).getText();
                    String cjn = ((JTextField) message[7]).getText();
                    try {
                        GameType gt = GameType.getGameType(sjn, scn, cjn, ccn);
                        DatabaseManager.getDatabase().storeGameType(gt);
                        model.fireTableDataChanged();
                    } catch (Exception ex) {
                        JOptionPane.showMessageDialog(root, ex.getMessage());
                    }
                }
            }
        });
        root.setLayout(new BoxLayout(root,BoxLayout.PAGE_AXIS));
        root.add(table);
        root.add(Box.createVerticalStrut(30));
        root.add(newGameTypeButton);
    }

    public Component getComponent() {
        return root;
    }

    private static class GameTypesModel extends AbstractTableModel {

        public int getColumnCount() {
            return 5;
        }

        public int getRowCount() {
            return GameType.gameTypeList.getGameTypes().length;
        }

        public Object getValueAt(int rowIndex, int columnIndex) {
            GameType gt = GameType.gameTypeList.getGameTypes()[rowIndex];
            switch (columnIndex) {
                case 0:
                    return gt.NAME;
                case 1:
                    return gt.getClientClassName();
                case 2:
                    return gt.getClientJarNames();
                case 3:
                    return gt.getServerClassName();
                case 4:
                    return gt.getServerJarNames();
                default:
                    return null;
            }
        }
    }
}
