/*    
    (C) 2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.goodgame.server.game;

import net.sf.goodgame.server.user.User;
import net.sf.goodgame.shared.UserType;
import net.sf.goodgame.shared.games.Player;

public final class GameResult {

    private User[] winners,losers,tie;
    /*
     *  If there was no tie, setup GameResult with this.
     *
     */
    public GameResult(Player[] win, Player[] lose)
    {
        winners = new User[win.length];
        losers = new User[lose.length];
        tie = null;
        for(int i = 0;i < win.length;i++)
        {
            User user = User.getUser(win[i].getUsername());
            System.out.println("Winner: "+user);
            if(user.getType() == UserType.guest)
            {
                winners = null;
                losers = null;
                return;
            }
            winners[i] = user;
        }
        for(int i = 0;i < lose.length;i++)
        {
            User user = User.getUser(lose[i].getUsername());
            System.out.println("Loser: "+user);
            if(user.getType() == UserType.guest)
            {
                winners = null;
                losers = null;
                return;
            }
            losers[i] = user;
        }
    }
    /*
     *  If there was a tie, put all of the players in here.
     */
    public GameResult(Player[] t)
    {
        this.winners = null;
        this.losers = null;
        tie = new User[t.length];
        for(int i = 0;i < t.length;i++)
        {
            User user = User.getUser(t[i].getUsername());
            System.out.println("Tie: "+user);
            if(user.getType() == UserType.guest)
            {
                tie = null;
                return;
            }
            tie[i] = user;
        }
    }
    public boolean wasTied()
    {
        return winners == null || losers == null;
    }
    public User[] getWinners()
    {
        return winners;
    }
    public User[] getLosers()
    {
        return losers;
    }
    public User[] getTie()
    {
        return tie;
    }
    public final boolean countsTowardsStats()
    {
        return (winners != null && losers != null) || tie!= null;
    }
}
