/*    
    (C) 2007,2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.goodgame.server.game;

import net.sf.goodgame.shared.games.table.GameTableRow;
import net.sf.goodgame.shared.games.Player;

public interface GameServer {

    void setServerGameListener(GameServerListener l);
    
    void destroy();

    void messageFromUser(Player player, String message);

    void messageFromUser(Player player, byte[] message);

    boolean canPlayerJoin();

    void playerJoined(Player player);

    void playerLeft(Player player);
    
    GameTableRow getGameTableRow();
}
