/*    
(C) 2007,2008 Michael Chaten
This file is part of Good Game.

Good Game is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

Good Game is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.server.game;

import net.sf.goodgame.shared.games.Player;

public interface GameServerListener {

    public void messageFromGame(String message, Player[] players);

    public void messageFromGame(byte[] message, Player[] players);

    /**
     *
     * @param result A result of the game.
     */
    public void gameResults(GameResult result);

    /**
     * When the game has started, call this.
     */
    public void gameStarted();

    /**
     * Call this when the game is over and no further people may join.
     * Note: You do not have to call this at the end of every round, that is what
     * Game results is for.
     */
    public void gameOver();

    /**
     * When this is called, the game will be available to join.
     */
    public void gameIsSetup();
}
