/*    
    (C) 2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.goodgame.server.game;

import java.util.HashMap;
import java.util.Map;
import net.sf.goodgame.server.List;
import net.sf.goodgame.server.networking.ServerToClientLogic;
import net.sf.goodgame.shared.network.NetworkMessage;
import net.sf.goodgame.shared.network.ServerToClientHeader;

/**
 *
 * @author Mike
 */
public class GameTypeList extends List<GameType>{

    private Map<Short, GameType> gameTypes;

    public GameTypeList() {
        super(ServerToClientHeader.addGameTypes);
        gameTypes = new HashMap<Short, GameType>();
    }

    public synchronized void add(GameType gt) {
        NetworkMessage addMessage = ServerToClientLogic.addGameTypes(gt);
        super.addData(gt, addMessage);
        gameTypes.put(gt.ID, gt);
        super.updateListeners(addMessage);
    }

    public GameType getGameType(short id) {
        return gameTypes.get(id);
    }

    public GameType[] getGameTypes() {
        return super.getData(new GameType[0]);
    }

}
