/*    
    (C) 2008 Michael Chaten
 	This file is part of GoodGame.

    GoodGame is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 3 of the License

    GoodGame is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.goodgame.server.lobby;

import java.util.HashMap;
import java.util.Map;
import net.sf.goodgame.server.*;
import net.sf.goodgame.server.networking.ServerToClientLogic;
import net.sf.goodgame.shared.network.NetworkMessage;
import net.sf.goodgame.shared.network.ServerToClientHeader;

/**
 *
 * @author Mike
 */
public class LobbyList extends List<Lobby>
{

    private Map<Short,Lobby> idMap;

    public LobbyList()
    {
        super(ServerToClientHeader.addLobbies);
        idMap = new HashMap<Short,Lobby>();
    }

    public synchronized void addLobby(Lobby lobby)
    {
        NetworkMessage networkMessage = ServerToClientLogic.addLobbies(lobby);
        super.addData(lobby, networkMessage);
        idMap.put(lobby.ID, lobby);
        super.updateListeners(networkMessage);

    }
    public synchronized Lobby[] getAll()
    {
        return super.getData(new Lobby[0]);
    }
    public synchronized Lobby getLobby(short id)
    {
        return idMap.get(id);
    }
}
