/*
(C) 2008 Michael Chaten
This file is part of GoodGame.

GoodGame is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

GoodGame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.server.persistence.jpa;

import java.io.Serializable;
import javax.persistence.Embeddable;

/**
 *
 * @author mchaten
 */
@Embeddable
public class FriendEntityID implements Serializable{

    private String friend;
    private String username;

    public FriendEntityID()
    {
        friend = null;
        username = null;
    }
    public FriendEntityID(FriendEntity entity)
    {
        friend = entity.getFriend();
        username = entity.getUsername();
    }
    public String getFriend() {
        return friend;
    }

    public void setFriend(String friend) {
        this.friend = friend;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String owner) {
        this.username = owner;
    }


    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final FriendEntityID other = (FriendEntityID) obj;
        if ((this.friend == null) ? (other.friend != null) : !this.friend.equals(other.friend)) {
            return false;
        }
        if ((this.username == null) ? (other.username != null) : !this.username.equals(other.username)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 17 * hash + (this.friend != null ? this.friend.hashCode() : 0);
        hash = 17 * hash + (this.username != null ? this.username.hashCode() : 0);
        return hash;
    }
}
