/*
(C) 2008 Michael Chaten
This file is part of GoodGame.

GoodGame is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

GoodGame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.server.persistence.jpa;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.Id;


/**
 *
 * @author mchaten
 */
@Entity
public class GameTypeEntity implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    private String name;
    private String serverJarNames;
    private String clientJarNames;
    private String serverClassName;
    private String clientClassName;

    public String getClientClassName() {
        return clientClassName;
    }

    public void setClientClassName(String clientClassName) {
        this.clientClassName = clientClassName;
    }

    public String getClientJarNames() {
        return clientJarNames;
    }

    public void setClientJarNames(String clientJarNames) {
        this.clientJarNames = clientJarNames;
    }

    public String getServerClassName() {
        return serverClassName;
    }

    public void setServerClassName(String serverClassName) {
        this.serverClassName = serverClassName;
    }

    public String getServerJarNames() {
        return serverJarNames;
    }

    public void setServerJarNames(String serverJarNames) {
        this.serverJarNames = serverJarNames;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (name != null ? name.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof GameTypeEntity)) {
            return false;
        }
        GameTypeEntity other = (GameTypeEntity) object;
        if ((this.name == null && other.name != null) || (this.name != null && !this.name.equals(other.name))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "net.sf.goodgame.server.persistence.jpa.GameTypeEntity[id=" + name + "]";
    }

}
