/*
(C) 2008 Michael Chaten
This file is part of GoodGame.

GoodGame is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

GoodGame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.server.persistence.jpa;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.IdClass;
import net.sf.goodgame.server.user.Results;

/**
 *
 * @author mchaten
 */
@Entity
@IdClass(net.sf.goodgame.server.persistence.jpa.UserResultsEntityID.class)
public class UserResultsEntity implements Serializable,Results {

    
    private static final long serialVersionUID = 1L;
    @Id
    private String username;
    @Id
    private String gameType;
    @Column(nullable=false)
    private int wins = 0;
    @Column(nullable=false)
    private int losses = 0;
    @Column(nullable=false)
    private int ties = 0;

    
    public int getLosses() {
        return losses;
    }

    public void setLosses(int losses) {
        this.losses = losses;
    }

    public int getTies() {
        return ties;
    }

    public void setTies(int ties) {
        this.ties = ties;
    }

    public int getWins() {
        return wins;
    }

    public void setWins(int wins) {
        this.wins = wins;
    }

    public String getGameType() {
        return gameType;
    }

    public void setGameType(String gametype) {
        this.gameType = gametype;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final UserResultsEntity other = (UserResultsEntity) obj;
        if ((this.username == null) ? (other.username != null) : !this.username.equals(other.username)) {
            return false;
        }
        if ((this.gameType == null) ? (other.gameType != null) : !this.gameType.equals(other.gameType)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + (this.username != null ? this.username.hashCode() : 0);
        hash = 89 * hash + (this.gameType != null ? this.gameType.hashCode() : 0);
        return hash;
    }

  
    

    @Override
    public String toString()
    {
        return "Wins: "+wins+", Losses: "+losses+", Ties: "+ties;
    }


}
