/*
(C) 2008 Michael Chaten
This file is part of GoodGame.

GoodGame is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 3 of the License

GoodGame is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.goodgame.server.persistence.jpa;

import java.io.Serializable;
import javax.persistence.Embeddable;

/**
 *
 * @author mchaten
 */
@Embeddable
public class UserResultsEntityID implements Serializable {

    private String username;
    private String gameType;

    public UserResultsEntityID()
    {
        username = null;
        gameType = null;
    }
    public UserResultsEntityID(UserResultsEntity entity)
    {
        username = entity.getUsername();
        gameType = entity.getGameType();
    }
    public String getGameType() {
        return gameType;
    }

    public void setGameType(String gameType) {
        this.gameType = gameType;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final UserResultsEntityID other = (UserResultsEntityID) obj;
        if ((this.username == null) ? (other.username != null) : !this.username.equals(other.username)) {
            return false;
        }
        if ((this.gameType == null) ? (other.gameType != null) : !this.gameType.equals(other.gameType)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 79 * hash + (this.username != null ? this.username.hashCode() : 0);
        hash = 79 * hash + (this.gameType != null ? this.gameType.hashCode() : 0);
        return hash;
    }




}
