package net.sf.goodgame.server.user;

import java.util.Collection;

public class FriendsList {

    private AllFriendsList allFriendsList;
    private OnlineFriendsList onlineFriendsList;

    public FriendsList(User user, Collection<String> friends) {
        allFriendsList = new AllFriendsList();
        onlineFriendsList = new OnlineFriendsList();
        for (String friend : friends) {
            addFriend(friend);
        }
        allFriendsList.addListener(user);
        onlineFriendsList.addListener(user);
    }

    public void addFriend(String friend) {
        allFriendsList.addFriend(friend);
        User friendUser = User.getUser(friend);
        if (friendUser != null) {
            friendLoggedIn(friendUser);
        }
    }

    public void removeFriend(String friend) {
        allFriendsList.removeFriend(friend);
        User user = User.getUser(friend);
        if (user != null) {
            friendLoggedOut(user);
        }
    }

    public void friendLoggedIn(User friend) {
        onlineFriendsList.friendLoggedIn(friend);
    }

    public void friendLoggedOut(User friend) {
        onlineFriendsList.friendLoggedOut(friend);
    }

    public void initialize() {
        allFriendsList.enable();
        onlineFriendsList.enable();
    }
}
