/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sf.goodgame.shared;

import java.security.NoSuchAlgorithmException;
import net.sf.goodgame.shared.network.InvalidMessageException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.MessageDigest;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.util.ArrayList;
import javax.crypto.Cipher;

/**
 *
 * @author Mike
 */
public class Util {

    private static KeyPairGenerator kpg;
    private static RSAPrivateKey privKey;
    private static RSAPublicKey pubKey;
    private static byte[] encodedPubKey;
    private static Cipher decrypt;
    private static Cipher encrypt;
    private static String cipher = "RSA";
    private static MessageDigest sha;

    static {
        try {
            sha = MessageDigest.getInstance("SHA");
            kpg = KeyPairGenerator.getInstance(cipher);
            decrypt = Cipher.getInstance(cipher);
            encrypt = Cipher.getInstance(cipher);
            kpg.initialize(1024);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static byte[] getEncodedPublicKey() {
        return encodedPubKey;
    }

    public static byte[] encrypt(byte[] message)  {
        try { 
            return encrypt.doFinal(message);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static byte[] decrypt(byte[] message) {
        try {
            return (decrypt.doFinal(message));
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public static byte[] sha(String s)
    {
            return sha.digest(s.getBytes());
    }
    public static void generateNewKeys() {

        KeyPair kp = kpg.generateKeyPair();
        privKey = (RSAPrivateKey) kp.getPrivate();
        pubKey = (RSAPublicKey) kp.getPublic();
        encodedPubKey = pubKey.getEncoded();
        setKeys(pubKey,privKey);

    }
    public static boolean canEncrypt()
    {
        return encrypt!=null;
    }
    public static void setKeys(RSAPublicKey publicKey, RSAPrivateKey privateKey)
    {
        try
        {
            if(publicKey != null)
            {
                encrypt.init(Cipher.ENCRYPT_MODE, publicKey);
                pubKey = publicKey;
            }
                
            if(privateKey!=null)
            {
                decrypt.init(Cipher.DECRYPT_MODE, privateKey);
                privKey = privateKey;
            }
        }catch(Exception e)
        {
            e.printStackTrace();
            encrypt = null;
            decrypt = null;
        }
    }

    public static byte[] combineArrays(byte[]... array) {
        int length = 0;
        for (byte[] array1 : array) {
            length += array1.length;
        }
        byte[] toReturn = new byte[length];
        int position = 0;
        for (byte[] array1 : array) {
            System.arraycopy(array1, 0, toReturn, position, array1.length);
            position += array1.length;
        }
        return toReturn;
    }
    //Methods for converting bytes recieved from the line to ints or shorts
    //And also for converting them to be able to be sent down the line.
    public static final byte[] intToByteArray(int value) {
        return new byte[]{
                    (byte) (value >>> 24), (byte) (value >> 16 & 0xff),
                    (byte) (value >> 8 & 0xff), (byte) (value & 0xff)
                };
    }

    public static final byte[] shortToByteArray(short value) {
        return new byte[]{
                    (byte) (value >>> 8), (byte) (value & 0xff)
                };
    }

    public static final int byteArrayToInt(byte[] value) throws InvalidMessageException {
        return byteArrayToInt(value, 0);
    }

    public static final int byteArrayToInt(byte[] value, int offset) throws InvalidMessageException {
        if (value.length + 3 > offset) {
            return (value[3 + offset] & 0xFF) | ((value[2 + offset] & 0xFF) << 8) | ((value[1 + offset] & 0xFF) << 16) | ((value[offset] & 0xFF) << 24);
        } else {
            throw new InvalidMessageException("Asked for an int when there was only " + (value.length - offset) + "bytes left");
        }
    }

    public static final short byteArrayToShort(byte[] value, int offset) throws InvalidMessageException {
        if (value.length + 1 > offset) {
            return (short) ((value[1 + offset] & 0xFF) | ((value[offset] & 0xFF) << 8));
        } else {
            throw new InvalidMessageException("Asked for a short when there was only 1 byte left");
        }
    }

    public static final short byteArrayToShort(byte[] value) throws InvalidMessageException {
        return byteArrayToShort(value, 0);
    }

    public static String[] split(String string, char delimiter) {
        char[] charArray = string.toCharArray();
        ArrayList<String> stringList = new ArrayList<String>();
        int begin = 0;
        for (int i = 0; i < charArray.length; i++) {
            char c = charArray[i];
            if (c == delimiter) {
                stringList.add(string.substring(begin, i));
                begin = i + 1;
            }
        }
        stringList.add(string.substring(begin, charArray.length));
        return stringList.toArray(new String[0]);

    }
    /*
     * Extracts a string from an array of bytes from an index to another index.
     * @return The string in the array from the offset with (length) length
     */

    public static String extractString(byte[] array, int offset, int length) {
        byte[] newArray = extractArray(array, offset, length);
        if (newArray == null) {
            return null;
        } else {
            return new String(newArray);
        }
    }

    public static byte[] extractArray(byte[] array, int offset, int length) {
        if (array.length >= offset + length && offset >= 0 && length >= 0) {
            byte[] newArray = new byte[length];
            System.arraycopy(array, offset, newArray, 0, length);
            return newArray;
        }
        return null;
    }
}