/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sf.goodgame.shared.network;

import net.sf.goodgame.shared.*;

/**
 *
 * @author Mike
 */
public enum ClientToServerHeader {

    handshake,
    login,
    logout,
    register,
    startGame,
    joinGame,
    leaveGame,
    createGame,
    chat,
    privateMessage,
    switchLobby,
    switchGameType,
    getUserInformation,
    setUserInformation,
    gameMessage,
    gameBytes,
    addFriend,
    removeFriend;
    public static final byte HEADER_SIZE = 2 + 2;//2 Bytes for the message num and 2 bytes for the size of the message.
    public final byte[] messageNumberArray;
    public final static short version = 1;

    ClientToServerHeader() {
        messageNumberArray = Util.shortToByteArray((short) ordinal());
    }

    public static ClientToServerHeader getHeader(short messageNumber) {
        ClientToServerHeader[] values = values();
        if (messageNumber >= 0 && values.length >= messageNumber) {
            return values[messageNumber];
        }
        return null;
    }
}
