/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.sf.goodgame.shared.network;

import net.sf.goodgame.shared.*;

/**
 *
 * @author Mike
 */
public enum ServerToClientHeader {

    handshake,
    oldVersion,
    loginOk,
    loginFailed,
    logout,
    switchLobby,
    switchGameType,
    addLobbies,
    modifyLobbies,
    removeLobbies,
    gameMessage,
    gameBytes,
    chat,
    privateMessage,
    addGames,
    modifyGames,
    removeGames,
    joinGame,
    leaveGame,
    createGame,
    loadGame,
    addUsers,
    modifyUsers,
    removeUsers,
    userInformation,
    addGameTypes,
    modifyGameTypes,
    removeGameTypes,
    serverMessage,
    addFriend,
    removeFriend,
    friendLoggedIn,
    friendLoggedOut;
    // 2 bytes for the message number. 2 bytes for the length of the data;
    public static final byte HEADER_SIZE = 2 + 2;
    public final byte[] messageNumberArray;
    public final static short version = 1;

    ServerToClientHeader() {
        messageNumberArray = Util.shortToByteArray((short) ordinal());
    }

    public static ServerToClientHeader getHeader(short messageNumber) {
        ServerToClientHeader[] values = values();
        if (messageNumber >= 0 && values.length >= messageNumber) {
            return values[messageNumber];
        }
        return null;
    }
}
